/*
 * Created on 25/06/2005
 *
 * Window - Preferences - Java - Code Style - Code Templates
 */
package br.eti.furutani.banco;

import java.io.IOException;
import java.io.InputStream;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Properties;

import org.apache.log4j.Logger;

/**
 * @author Roberto
 * 
 * Preferences - Java - Code Style - Code Templates
 */
public class ConexaoMySQL {
	
	private static Connection conn;
	private static Logger log = Logger.getLogger("ConexaoMySQL");
	private static Statement stm;

	private static void conectar() {
		try {
			Properties prop = carregarConfiguracoes();

			Class.forName("com.mysql.jdbc.Driver").newInstance();
			conn = DriverManager.getConnection("jdbc:mysql://localhost/"
					+ prop.getProperty("banco") + "?user="
					+ prop.getProperty("user") + "&password="
					+ prop.getProperty("senha")
					+ "&useUnicode=true&autoReconnect=true");
			stm = conn.createStatement();

		} catch (InstantiationException e) {
			System.out.println("No foi possivel instnciar o driver MySQL "
					+ e.toString());
		} catch (IllegalAccessException e) {
			System.out.println("No foi possivel instnciar o driver MySQL "
					+ e.toString());
		} catch (ClassNotFoundException e) {
			System.out.println("No foi possivel encontrar o driver MySQL "
					+ e.toString());
		} catch (SQLException e) {
			System.out.println("Erro Geral " + e.toString());
		}
	}

	/**
	 * @return Returns the conn.
	 * @throws FurutaniException
	 */
	public static Connection getConn() {
		if (conn == null) {
			conectar();
		}
		return conn;
	}

	/**
	 * @return Returns the stm.
	 * @throws SQLException
	 * @throws FurutaniException
	 */
	public static Statement getStm() {
		if (conn == null) {
			conectar();
		}

		try {
			stm = conn.createStatement();
		} catch (SQLException e) {
			e.printStackTrace();
			System.out.println("No foi possivel criar um Statement "
					+ e.toString());
		}
		return stm;
	}

	public static void fechaConexao() {
		try {
			conn.close();
		} catch (SQLException e) {
			e.printStackTrace();
			System.out.println("No foi possivel fechar a conexo "
					+ e.getMessage());
		}
	}

	public static Properties carregarConfiguracoes() {
		Properties prop = new Properties();
		InputStream is = null;
		System.out.println("Carregando configuraes");
		try {
			is = ConexaoMySQL.class.getResourceAsStream("bd.properties");
			prop.load(is);

		} catch (IOException e) {
			log.info("carregarConfiguracoes() " + e);
		}

		return prop;
	}
}
