package br.eti.furutani.dataset;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Date;
import java.util.Map;

import org.apache.log4j.Logger;
import org.jfree.data.general.DefaultPieDataset;

import br.eti.furutani.banco.ConexaoMySQL;
import de.laures.cewolf.DatasetProduceException;
import de.laures.cewolf.DatasetProducer;

public class CertificacaoEstadoDataSet implements DatasetProducer {

	private static final long serialVersionUID = 1L;
	Logger log = Logger.getLogger(CertificacaoEstadoDataSet.class);

	// Retorna uma Dataset com os dados que iro alimentar o grfico
	public Object produceDataset(Map arg0) throws DatasetProduceException {
		
		// Criando um Dataset para o grfico
		DefaultPieDataset ds = new DefaultPieDataset();
		
		PreparedStatement ps = null;

		String query = "SELECT p.estado, COUNT(p.estado) as qtde FROM `pessoa_has_certificacao` phc "
				+ "INNER JOIN `certificacao` c ON c.idCertificacao = phc.FK_idCertificacao "
				+ "INNER JOIN `pessoa` p ON p.idPessoa = phc.FK_idPessoa "
				+ "GROUP BY p.estado";
		try {
			
			Connection conexao = ConexaoMySQL.getConn();
			ps = conexao.prepareStatement(query);

			ResultSet rs = ps.executeQuery();

			while (rs.next()) {
				// Inserindo no DataSet o estado e a quantidade de pessoas certificadas
				ds.setValue(rs.getString(1), new Double(rs.getInt(2)));
			}
		} catch (SQLException e) {
			log.info(e);
		}

		return ds;
	}

	// O dados deste dataset  invalidado imediatamente. O tempo de retorno influencia no cache do cewolf
	public boolean hasExpired(Map arg0, Date arg1) {
		return true;
		// Se quisessemos que os dataset expirasse em 5 segundos colocariamos
		// return (System.currentTimeMillis() - since.getTime())  > 5000;
	}

	// Retorna um Id nico para o datset
	public String getProducerId() {
		return "CertificacaoPorEstado";
	}

}
